import java.util.*;

public class RoutePlanner {

    /**
     * Use approximation in A*
     */
    public boolean doApproximation;

    /**
     * The FactoryMap
     */
    private FactoryMap factoryMap;

    /**
     * GraphNode factory to create GraphNode objects
     */
    private GraphNode.GraphNodeCreator nodeCreator;

    /**
     * The currently selected node
     */
    private GraphNode currentPosition;

    /**
     * The target node
     */
    private GraphNode targetPosition;

    //TODO: Add your datastructures as fields

    /**
     * Initializes the RoutePlanner for running the A*-Algorithm steps with the doNextStep() method and marks the factoryMap accordingly
     *
     * @param factoryMap      the map to find the shortest path on
     * @param start           the startpoint of the path
     * @param target          the tragetpoint to find the shortest path to
     * @param doApproximation indicates if the approximation of A* should be used
     */
    public RoutePlanner(FactoryMap factoryMap, FactoryMap.MapPoint start, FactoryMap.MapPoint target, boolean doApproximation) {
        //TODO
    }

    public RoutePlanner(FactoryMap factoryMap, FactoryMap.MapPoint start, FactoryMap.MapPoint target) {
        this(factoryMap, start, target, true);
    }

    /**
     * Performs one round of the A*-Algorithm.
     * In each round a successor for the current node is selected by exploring the neighbouring nodes.
     * In the exploration process the nodes are updated accordingly with new distance information and previous nodes.
     * https://de.wikipedia.org/wiki/A*-Algorithmus
     * The algorithm finishes if the current node equals the target node.
     * The shortest path can then be retrieved by calling the getShortestPath() method
     * IMPORTANT: This method always marks the newly explored node with currentPosition.getPoint().setExplored()
     *
     * @return true if the algorithm has finished (i.e., currentPosition equals targetPosition) false if not
     * @throws RoutePlannerException if there is no valid path to the target
     */
    public boolean doNextStep() throws RoutePlannerException {
        if (currentPosition.equals(targetPosition))
            return true;
        //TODO
        return false;
    }

    /**
     * Retrives the shortest path if the algorithm has finished.
     *
     * @return
     * @throws RoutePlannerException if the algorithm has not finished yet.
     */
    public List<FactoryMap.MapPoint> getShortestPath() throws RoutePlannerException {
        if (!currentPosition.equals(targetPosition))
            throw new RoutePlannerException("Target not yet found");
        //TODO
        return null;
    }


    public FactoryMap getFactoryMap() {
        return factoryMap;
    }

    public GraphNode getCurrentPosition() {
        return currentPosition;
    }
}
